<?php 

// List of reserved module names

return [
    // NIVs
    'niv' => [
        'name'          => 'New International Version',
        'shortname'     => 'NIV',
        'lang_short'    => 'en',
        'desc'          => 'NIV, any year',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],    
    'niv_1978' => [
        'name'          => 'New International Version (1978)',
        'shortname'     => 'NIV 1978',
        'lang_short'    => 'en',
        'year'          => '1978',
        'desc'          => 'NIV, 1978 edition',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],     
    'niv_1984' => [
        'name'          => 'New International Version (1984)',
        'shortname'     => 'NIV 1984',
        'lang_short'    => 'en',
        'year'          => '1984',
        'desc'          => 'NIV, 1984 edition',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],    
    'niv_2011' => [
        'name'          => 'New International Version (2011)',
        'shortname'     => 'NIV 2011',
        'lang_short'    => 'en',
        'year'          => '2011',
        'desc'          => 'NIV, 2011 edition',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],

    // NASBs
    'nasb' => [
        'name'          => 'New American Standard Bible',
        'shortname'     => 'NASB',
        'lang_short'    => 'en',
        'desc'          => 'NASB, any year',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],  
    'nasb_1977' => [
        'name'          => 'New American Standard Bible (1977)',
        'shortname'     => 'NASB 1977',
        'desc'          => 'NASB, 1977 edition',
        'year'          => '1977',
        'lang_short'    => 'en',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],      
    'nasb_1995' => [
        'name'          => 'New American Standard Bible (1995)',
        'shortname'     => 'NASB 1995',
        'lang_short'    => 'en',
        'copyrighted'   => TRUE,
        'desc'          => 'NASB, 1995 edition',
        'year'          => '1995',
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],      
    'nasb_2020' => [
        'name'          => 'New American Standard Bible (2020)',
        'shortname'     => 'NASB 2020',
        'lang_short'    => 'en',
        'copyrighted'   => TRUE,
        'desc'          => 'NASB, 2020 edition',
        'year'          => '2020',
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],  

    // ESVs
    'esv' => [
        'name'          => 'English Standard Version',
        'shortname'     => 'ESV',
        'lang_short'    => 'en',
        'desc'          => 'ESV, any year',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ], 

    // (H)CSB
    'hcsb' => [
        'name'          => 'Holman Christian Standard Bible',
        'shortname'     => 'HCSB',
        'lang_short'    => 'en',
        'desc'          => 'HCSB, any year, up to 2009',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],      
    'csb' => [
        'name'          => 'Christian Standard Bible',
        'shortname'     => 'CSB',
        'lang_short'    => 'en',
        'desc'          => 'CSB, any year 2017 or later',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],     

    // KJV / TR based Bibles
    'nkjv' => [
        'name'          => 'New King James Version',
        'shortname'     => 'NKJV',
        'lang_short'    => 'en',
        'desc'          => 'NKJV, any year',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],      
    'mev' => [
        'name'          => 'Modern English Version',
        'shortname'     => 'MEV',
        'lang_short'    => 'en',
        'desc'          => 'MEV, any year',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],  

    // Paraphrases
    'living' => [
        'name'          => 'The Living Bible',
        'shortname'     => 'Living Bible',
        'lang_short'    => 'en',
        'desc'          => 'The Living Bible, any year',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],     
    'nlt' => [
        'name'          => 'New Living Translation',
        'shortname'     => 'NLT',
        'lang_short'    => 'en',
        'desc'          => 'NLT, any year',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ],     
    'message' => [
        'name'          => 'The Message',
        'shortname'     => 'Message',
        'lang_short'    => 'en',
        'desc'          => 'The Message, any year',
        'copyrighted'   => TRUE,
        'copyright_id'  => 4, // Standard, restrictive, proprietary copyright
    ], 
];
